// color class
// -Kyoung Shin Park (2011 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __COLOR_H__
#define __COLOR_H__

#include <windows.h>
#include <GL/gl.h>
#include "vector4.h"

namespace oglclass
{

class color : public vector4
{
public:
	static const color White;
	static const color Black;
	static const color Red;
	static const color Green;
	static const color Blue;
	static const color Cyan;
	static const color Magenta;
	static const color Yellow;

	static const color SkyBlue;
	static const color NavyBlue;
	static const color YellowGreen;
	static const color DarkGreen;
	static const color DarkYellow;
	static const color Maroon;
	static const color RedBrown;
	static const color DarkBrown;
	static const color GrayBrown;
	static const color Orange;

	static const color Grey10;
	static const color Grey20;
	static const color Grey30;
	static const color Grey40;
	static const color Grey50;
	static const color Grey60;
	static const color Grey70;
	static const color Grey80;
	static const color Grey90;

    color(void) : vector4(0.0, 0.0, 0.0, 1.0) {}
    color(float r, float g, float b, float a) : vector4(r, g, b, a) {}

	void enable(void) const { glColor4f(v_[0], v_[1], v_[2], v_[3]); }
};

}

#endif
