#include <windows.h>
#include <stdio.h>
#include <GL/glut.h>
#include "text.h"

//Ʈ(24-Roman)ڿ ϴ Լ
void drawBitmapString(char* str, GLfloat x, GLfloat y) // draw text
{
	glRasterPos3f(x, y, 0);
	int l = strlen(str);
	int i = 0;
	//ڿ ڸ ġκ ʷ Ѵ.
	while(i < l) {
		glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24, str[i++]);
	}
}

//Ʈũ ڿ(mono roman) ϴ Լ.
// ġ  ũ ڿ Ѵ.
void drawStrokeString(char* str, GLfloat x, GLfloat y, int size)
{
	glTranslatef(x, y, 0);
	glLineWidth(size / 10.0);
	glScalef(0.01, 0.01, 0);	//mono romanڿ ⺻ width 100̴.
	glScalef(size * 0.7, size, 0);	//mono romanڿ  Ƿ ¿ ¦ ߴ.
	int l = strlen(str);
	int i = 0;
	//ڿ  Ѵ.
	while(i < l) {
		glutStrokeCharacter(GLUT_STROKE_MONO_ROMAN, str[i++]);
	}
	glLineWidth(1);
}

// PLEASE READ THIS ARTICLE http://www.lighthouse3d.com/opengl/glut/index.php?bmpfontortho
// draw text in ortho projection
void Text::draw(int x, int y, GLfloat* color, char * string, ...)
{
	if (string == NULL)
		return;

	// ȿ 
	glPushAttrib(GL_ALL_ATTRIB_BITS);

	//ڿ  -ܻ̾  ߴ.
	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, color);

	// set orthographic projection =    
	GLint viewport[4];
	glGetIntegerv(GL_VIEWPORT, viewport);
	glMatrixMode(GL_PROJECTION);							// Select The Projection Matrix
	glPushMatrix();											// Store The Projection Matrix
	glLoadIdentity();										// Reset The Projection Matrix
	gluOrtho2D(0, viewport[2], 0, viewport[3]);				// Set Up An Ortho Screen
	//ȭ ǥ-ǥ   ȯ. ƮؽƮ ȸ, ũ⺯ȯ   Ƿ ̿Ͱ 
	glScalef(1, -1, 1);									
	glTranslatef(0, -viewport[3], 0);
	glMatrixMode(GL_MODELVIEW);								// Select The Modelview Matrix

		glPushMatrix();
		glLoadIdentity();

		//... κ ڿ   .
		char text[255];
		va_list ap;											// Pointer To List Of Arguments
		va_start(ap, string);										// Parses The String For Variables
		vsprintf(text, string, ap);								// And Converts Symbols To Actual Numbers
		va_end(ap);													// Results Are Stored In Text

		//ڿ 
		drawBitmapString(text, x, y);

		glPopMatrix();

	// reset perspective projection =  · ǵ
	glMatrixMode(GL_PROJECTION);							// Select The Projection Matrix
	glPopMatrix();											// Restore The Old Projection Matrix
	glMatrixMode(GL_MODELVIEW);								// Select The Modelview Matrix

	// ξ ȿ ǵ
	glPopAttrib();
}

/*
Ʈũ ڿ  , ٷ   ¦ ٲ㼭 ߰ Լ.
ũ   ִ. -Ű ٸǷ, Լ̸ Ȱ ϰ ߴ(ε)
*/
void Text::draw(int x, int y, int size, GLfloat *color, char *string, ...)
{
	//ڿ ,  .
	if (string == NULL)
		return;

	//ȿ 
	glPushAttrib(GL_ALL_ATTRIB_BITS);

	//  
	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, color);

	// set orthographic projection
	GLint viewport[4];
	glGetIntegerv(GL_VIEWPORT, viewport);
	glMatrixMode(GL_PROJECTION);							// Select The Projection Matrix
	glPushMatrix();											// Store The Projection Matrix
	glLoadIdentity();										// Reset The Projection Matrix
	gluOrtho2D(0, viewport[2], 0, viewport[3]);				// Set Up An Ortho Screen

	//⼭ ȭ  ʰ(Ʈũ ũ, ȸ  Ƿ)
	//ǥ  ÷ȴ.
	glTranslatef(0, viewport[3], 0);
	glMatrixMode(GL_MODELVIEW);								// Select The Modelview Matrix

		glPushMatrix();
		glLoadIdentity();

		char text[255];
		va_list ap;											// Pointer To List Of Arguments
		va_start(ap, string);										// Parses The String For Variables
		vsprintf(text, string, ap);								// And Converts Symbols To Actual Numbers
		va_end(ap);													// Results Are Stored In Text

		// ġ ڿ . y - ν   ǥ迡  ġ   ϰ Ѵ.
		drawStrokeString(text, x, -y, size);

		glPopMatrix();

	// reset perspective projection
	glMatrixMode(GL_PROJECTION);							// Select The Projection Matrix
	glPopMatrix();											// Restore The Old Projection Matrix
	glMatrixMode(GL_MODELVIEW);								// Select The Modelview Matrix
	glPopAttrib();
}

// Ʈ ؽƮ ̸ ȯϴ Լ.
int Text::textWidth(char* string, ...)
{
	if(string == NULL)
		return 0;

	//...κ óϴ ƾ( ) 
	char text[255];
	va_list ap;											// Pointer To List Of Arguments
	va_start(ap, string);										// Parses The String For Variables
	vsprintf(text, string, ap);								// And Converts Symbols To Actual Numbers
	va_end(ap);													// Results Are Stored In Text

	int width = 0;
	int l = strlen(string);
	int i = 0;
	//ڿ ̸ Ѵ.
	while(i < l){
		width += glutBitmapWidth(GLUT_BITMAP_TIMES_ROMAN_24, string[i++]);
	}
	return width;
}

// ũ Ʈũ ڿ ̸ ȯϴ Լ.
int Text::textWidth(int size, char* string, ...)
{
	if(string == NULL)
		return 0;
	
	//...κ ó ڿ ϴ κ
	char text[255];
	va_list ap;											// Pointer To List Of Arguments
	va_start(ap, string);										// Parses The String For Variables
	vsprintf(text, string, ap);								// And Converts Symbols To Actual Numbers
	va_end(ap);													// Results Are Stored In Text

	int width = 0;
	int l = strlen(text);
	int i = 0;
	//ڿ ̸ Ѵ.
	while(i < l){
		width += glutStrokeWidth(GLUT_STROKE_MONO_ROMAN, text[i++]);
	}
	return width * size / 100 * 0.7;
}