// weed class
// -Kyoung Shin Park (2010 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __WEED_H__
#define __WEED_H__

#include "geometry.h"

namespace oglclass
{
enum weedType {WEED_GRASS, WEED_HERB, WEED_BUSH};

class weed : public geometry
{
public:
	weed(void);
	virtual ~weed(void);
	virtual void draw();

	void setType(weedType type = WEED_GRASS) { weedType_ = type; };

private:
	weedType weedType_;
};

} // namespace

#endif