// matrix transformation class
// -Kyoung Shin Park (2010 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __MATRIX_TRANSFORM_H__
#define __MATRIX_TRANSFORM_H__

#include "matrix4x4.h"

namespace oglclass
{

class matrixtransform : public matrix4x4
{
public:
	matrixtransform(void) { identity(); }
	matrixtransform(float m0, float m4, float  m8, float m12,
					float m1, float m5, float  m9, float m13,
					float m2, float m6, float m10, float m14,
					float m3, float m7, float m11, float m15);
	matrixtransform(const matrix4x4& other);
	~matrixtransform(void) {}

	void multMatrix(void);
	void pushMatrix(void);
	void popMatrix(void);

	void setMatrix(const matrix4x4& m);
	void setMatrix(float * m);
};

} // namespace

#endif